
// Command controller for NoteTaker commands

var notetaker = {
  _cmds : { "notetaker-open-dialog":true,
            "notetaker-close-dialog":true,
            "notetaker-load":true,
            "notetaker-save":true,
            "notetaker-delete":true,
            "notetaker-nav-edit":true,
            "notetaker-nav-keywords":true
          },
  supportsCommand  : function (cmd) { return (cmd in this._cmds); },
  isCommandEnabled : function (cmd) { return true; },
  doCommand        : function (cmd) { return action(cmd); },
  onEvent          : function (cmd) { return true; }
};

// Catch-all controller for other commands

var detective = {
  supportsCommand  : function (cmd) { return true; },
  isCommandEnabled : function (cmd) { return true; },
  doCommand        : function (cmd) {
    throw("NoteTaker detective called on command: " + cmd);
    return true;
  },
  onEvent          : function (cmd) { return true; }
};

// Runtime execution

function execute(cmd)
{
  window.focus();
  try {
    var disp = document.commandDispatcher;
    var ctrl = disp.getControllerForCommand(cmd);
  }
  catch (e) {
    throw (" Command Unknown: " + cmd + ". Error: " + e);
  }
  ctrl.doCommand(cmd);
  window.focus();
}

// Installation

function install_controllers()
{
  window.controllers.appendController(notetaker);
  window.controllers.appendController(detective);
}

install_controllers();

